#include <stdio.h>
#include <stdlib.h>
#define GCC_VERSION (__GNUC__ * 10000 \
		+ __GNUC_MINOR__ * 100 \
		+ __GNUC_PATCHLEVEL__)

int main() {
	if ( GCC_VERSION != 90300 ) {
		printf("wrong gcc version: %d.%d.%d\n",
				__GNUC__,
				__GNUC_MINOR__,
				__GNUC_PATCHLEVEL__);
		// failing with RTE on purpose
		printf("%d\n", 1/0);
	}

	if ( __STDC_VERSION__ / 100 != 2011 ) {
		printf("wrong -std= option, expected -std=gnu11 but was: %ld\n", __STDC_VERSION__);
		// failing with RTE on purpose
		printf("%d\n", 1/0);
	}

#ifndef __OPTIMIZE__
	printf("Compiler optimizations seem to be disabled\n");
	// failing with RTE on purpose
	printf("%d\n", 1/0);
#else
	if ( __OPTIMIZE__ != 1 ) {
		printf("Compiler optimizations seem to be disabled\n");
		// failing with RTE on purpose
		printf("%d\n", 1/0);
	}
#endif

	printf("gcc version verified, erroring out with WA now\n");
	return 0;
}
