#include <cstdio>
#define GCC_VERSION (__GNUC__ * 10000 \
		+ __GNUC_MINOR__ * 100 \
		+ __GNUC_PATCHLEVEL__)

int main() {
	if ( GCC_VERSION != 90300 ) {
		printf("wrong g++ version: %d.%d.%d\n",
				__GNUC__,
				__GNUC_MINOR__,
				__GNUC_PATCHLEVEL__);
		// failing with RTE on purpose
		throw 42;
	}

	if ( __cplusplus / 100 != 2017 ) {
		printf("wrong -std= option, expected -std=gnu++17 but was: %ld\n", __cplusplus);
		// failing with RTE on purpose
		throw 42;
	}

#ifndef __OPTIMIZE__
	printf("Compiler optimizations seem to be disabled\n");
	// failing with RTE on purpose
	throw 42;
#else
	if ( __OPTIMIZE__ != 1 ) {
		printf("Compiler optimizations seem to be disabled\n");
		// failing with RTE on purpose
		throw 42;
	}
#endif

	printf("g++ version verified, erroring out with WA now\n");
	return 0;
}
