import java.io.*
import java.util.*
import java.lang.management.*

fun main() { // <--- note that this doesn't have any args and that's only possible starting with kotlin 1.3
    val version = System.getProperty("java.version")
    if (version !== "11.0.10") {
        throw RuntimeException("java.version incorrect, was $version")
    }

    val kversion = KotlinVersion.CURRENT.toString()
    if (!kversion.equals("1.4.21")) {
        throw RuntimeException("KotlinVersion.CURRENT incorrect, was $kversion")
    }

    val rbean = ManagementFactory.getRuntimeMXBean()
    val inputArgs = rbean.getInputArguments()

    for (arg in Arrays.asList("-Dfile.encoding=UTF-8", "-XX:+UseSerialGC", "-Xss128m", "-Xms1856m", "-Xmx1856m")) {
        if (!inputArgs.contains(arg)) {
            var allArgs = ""
            for (inputArg in inputArgs) allArgs = "$allArgs $inputArg"
            throw RuntimeException("cannot find $arg in JVM arguments ($allArgs)")
        }
    }

    print("Kotlin version verified, exiting with WA");
}
