#include <bits/stdc++.h>
using namespace std;
//template <class T> int size(const T &x) { return x.size(); }
#define rep(i,a,b) for (auto i=(a); i<(b); ++i)
#define iter(it,c) for (auto it = (c).begin(); it != (c).end(); ++it)
typedef pair<int, int> ii;
typedef vector<int> vi;
typedef vector<ii> vii;
typedef vector<vi> vvi;
typedef long long ll;
const int INF = 2147483647;
const ll DINF = 1000000000000000000LL;

struct num {
    ll xs, c;
    num(ll _xs=0, ll _c=0) : xs(_xs), c(_c) {
    }
    num operator +(const num &other) const {
        return num(
            xs + other.xs,
            c + other.c
        );
    }
    num operator -(const num &other) const {
        return num(
            xs - other.xs,
            c - other.c
        );
    }
    bool operator ==(const num &other) const {
        return xs == other.xs && c == other.c;
    }
    bool operator !=(const num &other) const {
        return !(*this == other);
    }
};

int main() {
    int n;
    cin >> n;

    vector<pair<ll,int> > gears(n);
    rep(i,0,n) {
        cin >> gears[i].first;
        gears[i].second = i;
    }
    sort(gears.begin(), gears.end());

    vector<bool> determined(n, false);
    vector<num> axle(n);
    vector<vector<pair<int,ll> > > adj(n);

    int m;
    cin >> m;
    rep(i,0,m) {
        int a, b;
        ll c;
        cin >> a >> b >> c;
        a--, b--;
        adj[a].push_back(make_pair(b, c));
        adj[b].push_back(make_pair(a, c));
    }

    axle[0] = num(1, 0);
    determined[0] = true;
    stack<int> S;
    S.push(0);

    bool single_x = false;
    ll single_x_value;

    while (!S.empty()) {
        int cur = S.top();
        S.pop();

        iter(it,adj[cur]) {
            int nxt = it->first;
            if (determined[nxt]) {
                num sub = axle[nxt] + axle[cur] - num(0, it->second);
                if (sub != num(0,0)) {
                    if (sub.xs == 0) {
                        cout << "impossible" << endl;
                        return 0;
                    }

                    ll cur_x = - sub.c / sub.xs;
                    if (single_x && cur_x != single_x_value) {
                        cout << "impossible" << endl;
                        return 0;
                    }
                    single_x = true;
                    single_x_value = cur_x;
                }
            } else {
                axle[nxt] = num(0, it->second) - axle[cur];
                determined[nxt] = true;
                S.push(nxt);
            }
        }
    }

    vector<ll> pot;

    ll mn_pos = DINF, mx_pos = -DINF;
    rep(i,0,n) {
        assert(abs(axle[i].xs) == 1);
        if (axle[i].xs == 1) {
            mn_pos = min(mn_pos, axle[i].c);
            mx_pos = max(mx_pos, axle[i].c);
        }
    }

    ll mn_neg = DINF, mx_neg = -DINF;
    rep(i,0,n) {
        assert(abs(axle[i].xs) == 1);
        if (axle[i].xs == -1) {
            mn_neg = min(mn_neg, axle[i].c);
            mx_neg = max(mx_neg, axle[i].c);
        }
    }

    vector<ll> pot_x;
    if (single_x) {
        pot_x.push_back(single_x_value);
    } else {
        if (mx_pos != -DINF) {
            pot_x.push_back(gears.back().first - mx_pos);
        }
        if (mn_pos != DINF) {
            pot_x.push_back(gears.back().first - mn_pos);
        }
        if (mx_neg != -DINF) {
            pot_x.push_back(mx_neg - gears.back().first);
        }
        if (mn_neg != DINF) {
            pot_x.push_back(mn_neg - gears.back().first);
        }
    }

    for (auto x : pot_x) {
        vector<pair<ll,int> > vals;
        rep(i,0,n) {
            vals.push_back(make_pair(axle[i].xs * x + axle[i].c, i));
        }
        sort(vals.begin(), vals.end());

        bool ok = true;
        vi ans(n);
        rep(i,0,n) {
            ok = ok && gears[i].first == vals[i].first;
            ans[vals[i].second] = gears[i].second;
        }
        if (ok) {
            rep(i,0,n) {
                if (i != 0) cout << " ";
                cout << ans[i]+1;
            }
            cout << endl;
            return 0;
        }
    }

    cout << "impossible" << endl;

    return 0;
}

