#include <climits>
#include <set>
#include <vector>
#include "validate.h"
using namespace std;

const int MAX_TRIES = 50, LEN = 4;

int main(int argc, char **argv) {
  init_io(argc,argv);
  
  string ans;
  judge_in >> ans;
  if(ans.length() != LEN)
    judge_error("Answer file must have length %d.\n", LEN);
  
  for (int q = 0; q < MAX_TRIES; q++) {
    string guess;
    if (!(author_out >> guess))
      wrong_answer("Wrong answer: expected a string.\n");
    if (guess.length() != LEN)
      wrong_answer("Wrong answer: guess must have length %d.\n", LEN);
    for(int i = 0; i < LEN; i++)
      if(guess[i] < 'a' || guess[i] > 'z')
	wrong_answer("Character %d is not a lowercase letter.\n", i);

    vector<bool> correct(LEN);
    int ncorrect = 0;
    for(int i = 0; i < LEN; i++) {
      correct[i] = (ans[i] == guess[i]);
      if(correct[i]) ncorrect++;
    }
    if(ncorrect == LEN) {
      cout << "correct" << endl;

      string trash;
      if (author_out >> trash) {
          wrong_answer("Wrong answer: trailing output.\n");
      }

      accept();
    }

    vector<bool> wrongpos(LEN, false);
    int nwrongpos = 0;
    for(int i = 0; i < LEN; i++) {
      if(correct[i]) continue;
      for(int j = 0; j < LEN; j++) {
	if(i == j || correct[j] || wrongpos[j]) continue;
	if(guess[i] == ans[j]) {
	  nwrongpos++;
	  wrongpos[j] = true;
	  break;
	}
      }
    }

    cout << ncorrect << " " << nwrongpos << endl;
  }

  wrong_answer("Did %d guesses without finding the correct answer.\n", MAX_TRIES);
}

