import java.io.*;
import java.util.*;

public class jeroen_random {
	public static void main(String[] args) throws Exception {
		BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
		Random rand = new Random();

		// Do random guesses that are consistent with earlier guesses
		ArrayList<String> guesses = new ArrayList<String>();
		ArrayList<Integer> correct = new ArrayList<Integer>();
		ArrayList<Integer> wrongpos = new ArrayList<Integer>();
		while(true) {
			String guess = "";
			for(int i = 0; i < 4; i++)
				guess += (char)('a' + rand.nextInt(26));

			boolean ok = true;
			for(int i = 0; ok && i < guesses.size(); i++)
				if(!consistent(guess, guesses.get(i), correct.get(i), wrongpos.get(i)))
					ok = false;

			if(ok) {
				System.err.println("Guessing " + guess);
				System.out.println(guess);
				System.out.flush();
				String line = in.readLine();
				if(line.equals("correct")) return;
				String[] ps = line.split(" ");
				guesses.add(guess);
				correct.add(Integer.valueOf(ps[0]));
				wrongpos.add(Integer.valueOf(ps[1]));
			} else {
				if(guess.equals("icpc"))
					System.err.println("Inconsistent " + guess);
			}
		}
	}
	
	private static boolean consistent(String guess, String prev, int c, int p) {
		int nc = 0, np = 0;
		boolean[] used = new boolean[4];
		for(int i = 0; i < 4; i++) {
			if(guess.charAt(i) == prev.charAt(i)) {
				used[i] = true;
				nc++;
			}
		}
		boolean[] usedwrong = new boolean[4];
		for(int i = 0; i < 4; i++) {
			if(used[i]) continue;
			for(int j = 0; j < 4; j++) {
				if(i == j || used[j] || usedwrong[j] || guess.charAt(i) != prev.charAt(j)) continue;
				np++;
				usedwrong[j] = true;
				break;
			}
		}
		return nc == c && np == p;
	}
}
